<?php
// PukiWiki - Yet another WikiWikiWeb clone
// $Id: imgr.inc.php,v 1.10 2008/02/28 takayan Exp $
// $Id: imgr.inc.php,v 1.02 2005/12/14 takayan Exp $
// source:
// $Id: ref.inc.php,v 1.48 2005/01/28 11:58:56 henoheno Exp $
//
// Image only reference plugin
// Include an attached image-file as an inline-image
//  Accept only relative path for file name
// v 1.10 : make "PLUGIN_IMGR_PAGE" parameter usable

// File icon image
if (! defined('FILE_ICON'))
	define('FILE_ICON',
	'<img src="' . IMAGE_DIR . 'file.png" width="20" height="20"' .
	' alt="file" style="border-width:0px" />');

/////////////////////////////////////////////////
// Default settings

// Horizontal alignment
define('PLUGIN_IMGR_DEFAULT_ALIGN', 'left'); // 'left', 'center', 'right'

// Text wrapping
define('PLUGIN_IMGR_WRAP_TABLE', FALSE); // TRUE, FALSE

// URL˲뤫
define('PLUGIN_IMGR_URL_GET_IMAGE_SIZE', FALSE); // FALSE, TRUE

// Ȥʤǥ쥯ȥ
// nullͰʳꤹ硢
// (1) index.php֤Ƥǥ쥯ȥˡХѥǵҤޤ
// (2) ե̾ "../"ʾ̥ǥ쥯ȥ껲ȡˤϻȤʤʤޤ
define('PLUGIN_IMGR_PAGE', '');
// ex1. define('PLUGIN_IMGR_PAGE', './image/');
// ex2. define('PLUGIN_IMGR_PAGE', '../');

// UPLOAD_DIR Υǡ(եΤ)ľܥ
define('PLUGIN_IMGR_DIRECT_ACCESS', FALSE); // FALSE or TRUE
// - ϽΥ饤󥤥᡼ߴΤ˻ĤΤ
//   ꡢ®ΤΥץǤϤޤ
// - UPLOAD_DIR WebСϪФƤꡢľܥ
//   Ǥ(¤ʤ)֤Ǥɬפޤ
// - Apache ʤɤǤ UPLOAD_DIR/.htaccess ɬפޤ
// - ֥饦ˤäƤϥ饤󥤥᡼ɽ䡢֥饤
//   ᡼ɽפʤɤԶ礬Ф礬ޤ

/////////////////////////////////////////////////

// Image suffixes allowed
define('PLUGIN_IMGR_IMAGE', '/\.(gif|png|jpe?g)$/i');

// is_file check to execute or not - when not check, there may happened to make a deadlink
//  1 : do execute is_file check, 0 : not execute
define('PLUGIN_IMGR_FILE_CHECK', 1);

// Usage (a part of)
define('PLUGIN_IMGR_USAGE', "(attached-file-name-in-relative-path[,parameters, ... ][,title])");

function plugin_imgr_inline()
{
	// Not reached, because of "$aryargs[] = & $body" at plugin.php
	// if (! func_num_args())
	//	return '&amp;imgr(): Usage:' . PLUGIN_IMGR_USAGE . ';';

	$params = plugin_imgr_body(func_get_args());

	if (isset($params['_error']) && $params['_error'] != '') {
		// Error
		return '&amp;imgr(): ' . $params['_error'] . ';';
	} else {
		return $params['_body'];
	}
}

function plugin_imgr_convert()
{
	if (! func_num_args())
		return '<p>#imgr(): Usage:' . PLUGIN_IMGR_USAGE . "</p>\n";

	$params = plugin_imgr_body(func_get_args());

	if (isset($params['_error']) && $params['_error'] != '') {
		return "<p>#imgr(): {$params['_error']}</p>\n";
	}

	if ((PLUGIN_IMGR_WRAP_TABLE && ! $params['nowrap']) || $params['wrap']) {
		// Ȥ
		// margin:auto
		//	Mozilla 1.x  = x (wrap,aroundʤ)
		//	Opera 6      = o
		//	Netscape 6   = x (wrap,aroundʤ)
		//	IE 6         = x (wrap,aroundʤ)
		// margin:0px
		//	Mozilla 1.x  = x (wrapǴ󤻤ʤ)
		//	Opera 6      = x (wrapǴ󤻤ʤ)
		//	Netscape 6   = x (wrapǴ󤻤ʤ)
		//	IE6          = o
		$margin = ($params['around'] ? '0px' : 'auto');
		$margin_align = ($params['_align'] == 'center') ? '' : ";margin-{$params['_align']}:0px";
		$params['_body'] = <<<EOD
<table class="style_table" style="margin:$margin$margin_align">
 <tr>
  <td class="style_td">{$params['_body']}</td>
 </tr>
</table>
EOD;
	}

	if ($params['around']) {
		$style = ($params['_align'] == 'right') ? 'float:right' : 'float:left';
	} else {
		$style = "text-align:{$params['_align']}";
	}

	// div
	return "<div class=\"img_margin\" style=\"$style\">{$params['_body']}</div>\n";
}

function plugin_imgr_body($args)
{
	global $script, $vars;
	// global $WikiName, $BracketName;  no need for this  // compat

	// 
	$params = array(
		'left'   => FALSE, // 
		'center' => FALSE, // 
		'right'  => FALSE, // 
		'wrap'   => FALSE, // TABLEǰϤ
		'nowrap' => FALSE, // TABLEǰϤޤʤ
		'around' => FALSE, // 
		'noicon' => FALSE, // ɽʤ
		'nolink' => FALSE, // եؤΥ󥯤ĥʤ
		'noimg'  => FALSE, // Ÿʤ
        '_blank' => FALSE, // ɥ򳫤 (nolinkȤȤ˻Ѥ̵)
		'zoom'   => FALSE, // Ĳݻ
		'_size'  => FALSE, // ꤢ
		'_w'     => 0,       // 
		'_h'     => 0,       // ⤵
		'_%'     => 0,     // Ψ
		'_args'  => array(),
		'_done'  => FALSE,
		'_error' => ''
	);

	// źեեΤؤδǥ쥯ȥ
	$page = PLUGIN_IMGR_PAGE;

	// źեեΥե̾
	$name = '';

	// źեեޤǤΥѥ(ºݤ)ե̾
	$file = '';

	// : "[ڡ̾/]źեե̾"뤤"URL"
	$name = array_shift($args);

	$matches = array();
	
	// 2008.02.28 v1.10 : 
	// remove heading "./" of file name if PLUGIN_IMGR_PAGE specified
	// heading "../" handles as an error if PLUGIN_IMGR_PAGE specified
	
	$pos2 = strpos($name , '../');
	$pos1 = strpos($name , './');
	
	if ($page != "") {
		if ($pos2 === 0) {
			$params['_error'] = htmlspecialchars('File name begins with "../" is not usable if PLUGIN_IMGR_PAGE is specified.' . $file);
			return $params;
		}
		elseif ($pos1 === 0) {
			$name_x = preg_replace('/\.\//', "", $name, 1);
		}
		else { $name_x = $name; }
	}
	else { $name_x = $name; }
	
	if (preg_match('#(^\.{1,2})(\/[0-9a-zA-Z_%=\'\(\)\;\:\$\-\+\?\!\*\#\.\&\@]{1,}){1,}#', $name, $matches)) {
		$file = $page . $name_x; // concatinate $page & $name ... use $file on following logic

	// 2008.02.28 v1.10 : 

		if (PLUGIN_IMGR_FILE_CHECK) {
		$is_file = is_file($file);
			if (! $is_file) {
				$params['_error'] = htmlspecialchars('File not found: "' . $file . '"');
				return $params;
			}
		}
		$is_image = (preg_match(PLUGIN_IMGR_IMAGE, $file));
		if (! $is_image) {
			$params['_error'] = htmlspecialchars('File specification ' . $file . ' is invalid for imgr plugin : allows only .jp(e)g/.gif/.png');
			return $params;
		}
	} else {
		$params['_error'] = htmlspecialchars('File specification ' . $file . ' is invalid for imgr plugin : allows only relative path for file name');
		return $params;
	}


	// Ĥΰν
	if (! empty($args))
		foreach ($args as $arg)
			imgr_check_arg($arg, $params);

/*
 $nameȤ˰ʲѿ
 $url : URL
 $title :ȥ
 $is_image : ΤȤTRUE / ʳξ
 $info : getimagesize()'size'
*/
	$title = $url = $info = '';
	$width = $height = 0;
	$matches = array();

	//  if ($is_url) {   ٤ref pluginURLǽ	// URL
	$url = htmlspecialchars($page . $name_x); //  2008/02/28
	$title = htmlspecialchars(preg_match('/([^\/]+)$/', $name, $matches) ? $matches[1] : $url);

	if (PLUGIN_IMGR_URL_GET_IMAGE_SIZE && (bool)ini_get('allow_url_fopen')) {
		$size = @getimagesize($name);
		if (is_array($size)) {
			$width  = $size[0];
			$height = $size[1];
			$info   = $size[3];
		}
	} else {
		$width = $height = 0;
		$size = @getimagesize($file);
		if (is_array($size)) {
			$width  = $size[0];
			$height = $size[1];
		}
	}

	// ĥѥ᡼å
	if (! empty($params['_args'])) {
		$_title = array();
		foreach ($params['_args'] as $arg) {
			if (preg_match('/^([0-9]+)x([0-9]+)$/', $arg, $matches)) {
				$params['_size'] = TRUE;
				$params['_w'] = $matches[1];
				$params['_h'] = $matches[2];

			} else if (preg_match('/^([0-9.]+)%$/', $arg, $matches) && $matches[1] > 0) {
				$params['_%'] = $matches[1];

			} else {
				$_title[] = $arg;
			}
		}

		if (! empty($_title)) {
			$title = htmlspecialchars(join(',', $_title));
			if ($is_image) $title = make_line_rules($title);
		}
	}

	// Ĵ
	if ($is_image) {
		// ꤵ줿Ѥ
		if ($params['_size']) {
			if ($width == 0 && $height == 0) {
				$width  = $params['_w'];
				$height = $params['_h'];
			} else if ($params['zoom']) {
				$_w = $params['_w'] ? $width  / $params['_w'] : 0;
				$_h = $params['_h'] ? $height / $params['_h'] : 0;
				$zoom = max($_w, $_h);
				if ($zoom) {
					$width  = (int)($width  / $zoom);
					$height = (int)($height / $zoom);
				}
			} else {
				$width  = $params['_w'] ? $params['_w'] : $width;
				$height = $params['_h'] ? $params['_h'] : $height;
			}
		}
		if ($params['_%']) {
			$width  = (int)($width  * $params['_%'] / 100);
			$height = (int)($height * $params['_%'] / 100);
		}
		if ($width && $height) $info = "width=\"$width\" height=\"$height\" ";
	}

	// 饤Ƚ
	$params['_align'] = PLUGIN_IMGR_DEFAULT_ALIGN;
	foreach (array('right', 'left', 'center') as $align) {
		if ($params[$align])  {
			$params['_align'] = $align;
			break;
		}
	}

	if ($params['noimg']) {
		$icon = FILE_ICON;
        if ($params['_blank']) {
            $params['_body'] = "<a href=\"$url\" title=\"$title\" target=\"_blank\">$icon$title</a>";
        } else {
		$params['_body'] = "<a href=\"$url\" title=\"$title\">$icon$title</a>";
        }
	} else {
		$params['_body'] = "<img src=\"$url\" alt=\"$title\" title=\"$title\" $info/>";
		if (! $params['nolink']) {
            if ($params['_blank']) {
			    $params['_body'] = "<a href=\"$url\" title=\"$title\" target=\"_blank\">{$params['_body']}</a>";
            } else
			    $params['_body'] = "<a href=\"$url\" title=\"$title\">{$params['_body']}</a>";
		}
	}

	return $params;
}

// ץϤ
function imgr_check_arg($val, & $params)
{
	if ($val == '') {
		$params['_done'] = TRUE;
		return;
	}

	if (! $params['_done']) {
		foreach (array_keys($params) as $key) {
			if (strpos($key, strtolower($val)) === 0) {
				$params[$key] = TRUE;
				return;
			}
		}
		$params['_done'] = TRUE;
	}

	$params['_args'][] = $val;
}

?>
